Korek/Models/Corporate.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Korek.Models
{
    using System;
    using System.Collections.Generic;
    
    public partial class Corporate
    {
        public int CorporateID { get; set; }
        public Nullable<int> UniqueNumber { get; set; }
        public string Name { get; set; }
        public string Address { get; set; }
    }
}

Korek/Controllers/CorporateController.cs
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Korek.Models;

namespace Korek.Controllers
{
    public class CorporateController : Controller
    {
        // GET: Corporate
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult GetData()
        {
            using (DBModels db = new DBModels())
            {
                List<Corporate> empList = db.Corporates.ToList<Corporate>();
                return Json(new { data = empList }, JsonRequestBehavior.AllowGet);
            }
        }

        [HttpGet]
        public ActionResult AddOrEdit(int id = 0)
        {
            if (id == 0)
                return View(new Corporate());
            else
            {
                using (DBModels db = new DBModels())
                {
                    return View(db.Corporates.Where(x => x.CorporateID == id).FirstOrDefault<Corporate>());
                }
            }
        }

        [HttpPost]
        public ActionResult AddOrEdit(Corporate cor)
        {
            using (DBModels db = new DBModels())
            {
                if (cor.CorporateID == 0)
                {
                    db.Corporates.Add(cor);
                    db.SaveChanges();
                    return Json(new { success = true, message = "Save Successfuly" }, JsonRequestBehavior.AllowGet);
                }
                else
                {
                    db.Entry(cor).State = EntityState.Modified;
                    db.SaveChanges();
                    return Json(new { success = true, message = "Update Successfuly" }, JsonRequestBehavior.AllowGet);
                }
            }
        }

        [HttpPost]
        public ActionResult Delete(int id)
        {
            using (DBModels db = new DBModels())
            {
                Corporate cor = db.Corporates.Where(x => x.CorporateID == id).FirstOrDefault<Corporate>();
                db.Corporates.Remove(cor);
                db.SaveChanges();
                return Json(new { success = true, message = "Deleted Successfully" }, JsonRequestBehavior.AllowGet);
            }
        }

        [HttpGet]
        public ActionResult Show(int id = 0)
        {
            if (id == 0)
                return View(new Corporate());
            else
            {
                using (DBModels db = new DBModels())
                {
                    return View(db.Corporates.Where(x => x.CorporateID == id).FirstOrDefault<Corporate>());
                }
            }
        }

        [HttpGet]
        public ActionResult GetSimcards(int id = 0)
        {
            if (id == 0)
                return View(new Corporate());
            else
            {
                using (DBModels db = new DBModels())
                {
                    List<Simcard> simcards = db.Simcards.Where(x => x.CorporateID == id).ToList<Simcard>();
                    return Json(new { data = simcards }, JsonRequestBehavior.AllowGet);
                }
            }
        }
    }
}

Korek/Controllers/SimcardController.cs
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Korek.Models;

namespace Korek.Controllers
{
    public class SimcardController : Controller
    {
        // GET: Simcard
        public ActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public ActionResult AddOrEdit(int id = 0, int simId = 0)
        {
            ViewBag.Id = id;
            if (simId == 0)
                return View(new Simcard());
            else
            {
                using (DBModels db = new DBModels())
                {
                    return View(db.Simcards.Where(x => x.SimcardID == simId).Where(x => x.CorporateID == id).FirstOrDefault<Simcard>());
                }
            }
        }

        [HttpPost]
        public ActionResult AddOrEdit(Simcard simcard)
        {
            using (DBModels db = new DBModels())
            {
                if (simcard.SimcardID == 0)
                {
                    db.Simcards.Add(simcard);
                    db.SaveChanges();
                    return Json(new { success = true, message = "Save Successfuly" }, JsonRequestBehavior.AllowGet);
                }
                else
                {
                    db.Entry(simcard).State = EntityState.Modified;
                    db.SaveChanges();
                    return Json(new { success = true, message = "Update Successfuly" }, JsonRequestBehavior.AllowGet);
                }
            }
        }

        [HttpPost]
        public ActionResult Delete(int id)
        {
            using (DBModels db = new DBModels())
            {
                Simcard simcard = db.Simcards.Where(x => x.CorporateID == id).FirstOrDefault<Simcard>();
                db.Simcards.Remove(simcard);
                db.SaveChanges();
                return Json(new { success = true, message = "Deleted Successfully" }, JsonRequestBehavior.AllowGet);
            }
        }
    }
}

Korek/Views/Corporate/AddOrEdit.cshtml
@using System
@model Korek.Models.Corporate
@{
    Layout = null;
}

@using (Html.BeginForm("AddOrEdit", "Corporate", FormMethod.Post, new { onsubmit = "return SubmitForm(this)" }))
{
    @Html.HiddenFor(model => model.CorporateID)

    @Html.HiddenFor(model => model.UniqueNumber, new { Value = @GetHashCode() })
    <div class="form-group">
        @Html.LabelFor(model => model.Name, new { @class = "control-label" })
        @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
        @Html.ValidationMessageFor(model => model.Name)
    </div>
    <div class="form-group">
        @Html.LabelFor(model => model.Address, new { @class = "control-label" })
        @Html.EditorFor(model => model.Address, new { htmlAttributes = new { @class = "form-control" } })
        @Html.ValidationMessageFor(model => model.Address)
    </div>
    <div class="form-group">
        <input type="submit" value="Submit" class="btn btn-dark" />
        <input type="reset" value="Reset" class="btn btn-default" />
    </div>
}

Korek/Views/Corporate/Index.cshtml
@{
    ViewBag.Title = "Corporate Lists";
}

<h2>Corporate Lists</h2>

<a class="btn btn-light" style="margin-bottom: 10px" onclick="PopupForm('@Url.Action("AddOrEdit", "Corporate")')"> <i class="fa fa-plus"></i> Add New</a>

<table id="corporateTable" class="table table-striped table-bordered" style="width: 100%">
    <thead>
        <tr>
            <th>Unique Number</th>
            <th>Corporate Name</th>
            <th>Address</th>
            <th></th>
        </tr>
    </thead>
</table>

<link href="https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css" rel="stylesheet" />
<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" />

@section scripts {
    <script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js"></script>
    <script>
        var Popup, dataTable;
        $(document).ready(function () {
            dataTable = $("#corporateTable").DataTable({
                "ajax": {
                    "url": "/Corporate/GetData",
                    "type": "GET",
                    "datatype": "json"
                },
                "columns": [
                    { "data": "UniqueNumber" },
                    { "data": "Name" },
                    { "data": "Address" },
                    {
                        "data": "CorporateID", "render": function (data) {
                            return `<a class='btn btn-light btn-sm' href="@Url.Action("show", "Corporate")/${data}"><i class='fa fa-eye'></i> Details</a>
                                    <a class='btn btn-light btn-sm' onclick="PopupForm('/Corporate/AddOrEdit/${data}')"><i class='fa fa-pencil'></i> Edit</a>
                                    <a class='btn btn-danger btn-sm text-default text-light' style='margin-left:5px;' onclick=Delete("${data}")><i class='fa fa-trash'></i> Delete</a>`
                        },
                        "orderable": false,
                        "searchable": false,
                        "width": "240px"
                    }
                ],
                "language": {
                    "emptyTable": "No Records"
                }
            });
        });
        function PopupForm(url) {
            var formDiv = $('<div/>');
            $.get(url)
                .done(function (response) {
                    formDiv.html(response);
                    Popup = formDiv.dialog({
                        autoOpen: true,
                        resizable: false,
                        title: 'Fill Corporate Details',
                        height: 300,
                        width: 400,
                        close: function () {
                            Popup.dialog('destroy').remove();
                        }
                    });
                });
        }
        function SubmitForm(form) {
            $.validator.unobtrusive.parse(form);
            if ($(form).valid()) {
                $.ajax({
                    type: "POST",
                    url: form.action,
                    data: $(form).serialize(),
                    success: function (data) {
                        if (data.success) {
                            Popup.dialog('close');
                            dataTable.ajax.reload();
                            $.notify(data.message, {
                                globalPosition: "top center",
                                className: "success"
                            })
                        }
                    }
                });
            }
            return false;
        }
        function Delete(id) {
            if (confirm('Are you sure to delete this Corporate record?')) {
                $.ajax({
                    type: "POST",
                    url: '@Url.Action("Delete", "Corporate")/' + id,
                    success: function (data) {
                        if (data.success) {
                            dataTable.ajax.reload();
                            $.notify(data.message, {
                                globalPosition: "top center",
                                className: "success"
                            })
                        }
                    }
                });
            }
        }
    </script>
}

Korek/Views/Corporate/Show.cshtml
@model Korek.Models.Corporate
@{
    ViewBag.Title = "Corporate Details | SIM Cards List";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<h2>Corporate Details:</h2>
<div class="row">
    <div class="col-md-4">
        <div class="card">
            <div class="card-body">
                <b>Unique Number:</b> @Model.UniqueNumber <br />
                <b>Corporate Name:</b> @Model.Name <br />
                <b>Address:</b> @Model.Address <br />
            </div>
        </div>
    </div>
</div>
<a class="btn btn-light" style="margin-bottom: 10px; margin-top: 10px;" onclick="PopupForm('@Url.Action("AddOrEdit", "Simcard")/@Model.CorporateID')"> <i class="fa fa-plus"></i> Add SIM Card</a>
<table id="simcardTable" class="table table-striped table-bordered" style="width: 100%">
    <thead>
        <tr>
            <th>SIM Card Number</th>
            <th>Customer Name</th>
            <th></th>
        </tr>
    </thead>
</table>
<link href="https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css" rel="stylesheet" />
<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" />
@section scripts {
    <script src="//cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js"></script>
    <script>
        var Popup, dataTable

        $(document).ready(function () {
            dataTable = $("#simcardTable").DataTable({
                "ajax": {
                    "url": "/Corporate/GetSimcards/@Model.CorporateID",
                    "type": "GET",
                    "datatype": "json"
                },
                "columns": [
                    { "data": "Number" },
                    { "data": "CustomerName" },
                    {
                        "data": "SimcardID", "render": function (data) {
                            console.log(data);
                            return `<a class='btn btn-light btn-sm' onclick="PopupForm('@Url.Action("AddOrEdit", "Simcard")/@Model.CorporateID/${data}')"><i class='fa fa-pencil'></i> Edit</a>
                                    <a class='btn btn-danger btn-sm text-default text-light' style='margin-left:5px;' onclick=Delete("${data}")><i class='fa fa-trash'></i> Delete</a>`
                        },
                        "orderable": false,
                        "searchable": false,
                        "width": "240px"
                    }
                ],
                "language": {
                    "emptyTable": "No Records"
                }
            });
        });

        function PopupForm(url) {
            var formDiv = $('<div/>');
            $.get(url)
                .done(function (response) {
                    formDiv.html(response);

                    Popup = formDiv.dialog({
                        autoOpen: true,
                        resizable: false,
                        title: 'Fill SIM Card Details',
                        height: 400,
                        width: 700,
                        close: function () {
                            Popup.dialog('destroy').remove();
                        }
                    });
                });
        }

        function SubmitForm(form) {
            $.validator.unobtrusive.parse(form);
            if ($(form).valid()) {
                $.ajax({
                    type: "POST",
                    url: form.action,
                    data: $(form).serialize(),
                    success: function (data) {
                        if (data.success) {
                            Popup.dialog('close');
                            dataTable.ajax.reload();

                            $.notify(data.message, {
                                globalPosition: "top center",
                                className: "success"
                            })
                        }
                    }
                });
            }
            return false;
        }

        function Delete(id) {
            if (confirm('Are you sure to delete this SIM Card record?')) {
                $.ajax({
                    type: "POST",
                    url: '@Url.Action("Delete", "Simcard")/' + @Model.CorporateID + '/' + id,
                    success: function (data) {
                        if (data.success) {
                            dataTable.ajax.reload();

                            $.notify(data.message, {
                                globalPosition: "top center",
                                className: "success"
                            })
                        }
                    }
                });
            }
        }
    </script>
}